<?php declare(strict_types=1);

define( 'WP_USE_THEMES', false );
require_once __DIR__ . '/../../../../wp-blog-header.php';

use Everyware\Plugin\CacheInvalidator\DataStorage;
use Everyware\Plugin\CacheInvalidator\LedgeInvalidator;

status_header(200);

$inputData = json_decode(file_get_contents('php://input'));

if(isset($inputData->streamId)) {

    $dataStorage = new DataStorage();
    $streamId = $inputData->streamId;

    $items = $dataStorage->getItemsByListenerId($streamId);
    if($items !== false && count($items) > 0) {

        foreach($items as $item) {
            if(isset($item->page_id)) {
                $pageUrl = get_permalink($item->page_id);
                LedgeInvalidator::invalidateUrl($pageUrl, $streamId);

            }
            else if(isset($item->page_url)) {
                LedgeInvalidator::invalidateUrl($item->page_url, $streamId);
            }
        }
    }
    else {
        wp_send_json([
            'message' => 'Could not find any matching documents.'
        ], 404);
    }
}
